<?php
/*******************************************************************************
*	This file is part of Woogle4MediaWiki
*   (http://www.mediawiki.org/wiki/Extension:Woogle4MediaWiki)
*
*	Copyright (c) 2007 - 2009 Hans-Jörg Happel and
*	FZI Forschungszentrum Informatik and der Universität Karlsruhe (TH)
*
*   Woogle4MediaWiki is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   Woogle4MediaWiki is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with Woogle4MediaWiki.  If not, see <http://www.gnu.org/licenses/>.
*******************************************************************************/ 

class WoogleQueryServiceCommon {
	public static $id_prefix = "urn:mediawiki:";
	public static $mimetypePrimaryType = "text";
	public static $mimetypeSubType = "mediawiki";
	public static $source = "mediawiki";
	public static $scope = "all";
	public static $genre = "wiki";
	public static $language = "en";
	
	public static function getId($id) {
		WoogleUtil::profileIn(__METHOD__);
		// from org.teamweaver.is.backend.crawl.MediaWikiCrawler.createDataObject:219
		// MEDIAWIKI_DEFAULT_NS + mediaWikiBaseURL + p.getId()
		$retVal = self::$id_prefix . WoogleMWUtil::getWikiAbsolutePath() . $id;
		WoogleUtil::profileOut(__METHOD__);
		return $retVal;
	}
	
	public static function getMimetype() {
		WoogleUtil::profileIn(__METHOD__);
		$retVal = self::$mimetypePrimaryType . '/' . self::$mimetypeSubType;
		WoogleUtil::profileOut(__METHOD__);
		return $retVal;
	}
	
	public static function getRepository() {
		WoogleUtil::profileIn(__METHOD__);
		$retVal = WoogleConfig::get('indexRepository');
		WoogleUtil::profileOut(__METHOD__);
		return $retVal;
	}
}

?>
