<?php

require_once('Woogle_TestCase.php');

class WoogleIndexServiceNativeTest extends Woogle_TestCase{
	

    protected function setUp(){
    	$this->prepareTestDb();
		$this->prepareTestIndex();
	}
	
	/* Test methods */
	
	public function testCheckIndexService(){
		
		// wrong
		$tmp = WoogleLucene::getIndexPath();
		WoogleLucene::setIndexPath('Z:\_wrongPath');
		$this->assertFalse($this->is->checkIndexService());
		WoogleLucene::setIndexPath($tmp);
		
		// current
		$this->assertTrue($this->is->checkIndexService());
		
	}
	
	public function testGetIndexFileSize(){
		echo $this->is->getIndexFileSize();
		// TODO
		//$this->assertTrue($this->is->getIndexFileSize() < 0.1);
	}
	
	public function testCommitIndex(){
		// TODO
	}
	
	public function testDoAddItems(){
		// TODO
	}
	
	public function testDoUpdateItem(){
		// TODO
	}
	
	// this also covers exists(), doAddItem() and doDeleteItem()
	public function testNumDocs(){
		
		$this->assertEquals($this->num_test_docs, $this->is->numDocs());
		
		$wd = new WoogleDocument();
		$wd->setId(WoogleQueryServiceCommon::getId('999'));
		$wd->setShortId('999');
		$wd->setLabel('Page999');
		$wd->setContent('This is content');
		$wd->setUri('http://localhost/wiki/Page999');
		
		// add
		$this->is->doAddItem($wd, true);
		$this->is->commitIndex();
		$this->assertEquals($this->num_test_docs+1, $this->is->numDocs());
		
		// remove
		$this->assertTrue($this->is->exists($wd->getShortId()));
		$this->is->doDeleteItem($wd->getShortId());
		$this->is->commitIndex();
		WoogleLucene::optimizeIndex();	// otherwise, exists will return true, although document marked deleted
		$this->assertFalse($this->is->exists($wd->getShortId()));
		$this->assertEquals($this->num_test_docs, $this->is->numDocs());

	}

	public function testIndexAll(){
		
		$this->assertEquals($this->num_test_docs, $this->is->numDocs());
		//$this->assertEquals(0, $this->is->numDocs());
		$this->is->index(true); // index all
		$this->assertEquals($this->num_test_docs, $this->is->numDocs());
		
		// TODO add imagedata
	}
	


	
	
}



?>
