<?php

require_once('Woogle_TestCase.php');

class WoogleQueryManagerNativeScalabilityTest extends Woogle_TestCase{
	
    protected function setUp(){
//		echo "\n Calling setUp()";
    	$this->prepareTestDb();
		//$this->prepareTestIndex();
		//$this->prepareQueryService();	
    	$this->qm = WoogleUtil::getQueryManager();
   	  	$this->prepareQueryTestData();
    }
	
	protected function tearDown(){
//		echo "\n Calling tearDown()";
		$this->removeQueryTestData();
		unset($this->qm);
	}
	
	/* Test methods */
	
	public function testScalability(){
		WoogleConfig::set('useDebugLogging', false);
		
		// RandomQueryGeneration-Time: 657.62565612793 for 10000 queries
		// create 10k queries
		$this->prepareMuchQueryTestData(50000);
		$max = $avg = 0;
		$min = 1000;
		// ask for related queries 100 times
		for ($i = 1; $i <= 500; $i++) {
			$rnd = rand(1, 100000);
			$rq = substr(md5($rnd), 0, 2);
			$qStart = microtime(true);
			$rx = $this->qm->getRelatedQueries($rq, 10, false);
			echo 'Retrieved ' . count($rx) . ' related queries for query ' . $rq . "\n";
			$qStop = microtime(true);
			$qTime = $qStop - $qStart;
			$max = max($max, $qTime);
			$min = min($min, $qTime);
			$avg = (($avg * $i-1) + $qTime ) / $i;
		}
		
		echo 'scalability test' . "\n";
		echo ' - Max:' . $max . "\n";
		echo ' - Min:' . $min . "\n";
		echo ' - Avg:' . $avg . "\n";
		WoogleConfig::set('useDebugLogging', true);
	}
	
}


?>
