<?php

require_once('Woogle_TestCase.php');
require_once('MockUser.php');

class WoogleUtilTest extends Woogle_TestCase{
	
	public function setUp(){
	    $this->prepareTestDb();
	}
	
	public function tearDown(){
	
	}
	
	/* Test methods */	
	
	public function testDb(){
	
		// TODO unclear?
	
		/*
		$db = WoogleMWUtil::getDB();
		extract($db->tableNames('page', 'text'));
		$sql =	'SELECT pg.page_title AS title, tx.old_text AS text ' .
				'FROM ' . $page . ' pg INNER JOIN ' . $text . ' tx ON pg.page_latest = tx.old_id;';
		$res = $db->doQuery($sql);
		
		//echo $sql;

		while ($row = $db->fetchObject($res)) {
			echo 'Title:' . substr($row->title,0,10) . ' - Text:' . substr($row->text,0,10) . ' EXT';
		}
		*/
	}
	
	 public function testPaths(){
		$this->assertNotNull(WoogleUtil::getLogPath());		
		$this->assertTrue(file_exists(WoogleUtil::getLogPath()));

		/*
		TODO - not OK - check this!
		
		//echo " 1 " . WoogleUtil::getWoogleAbsolutePath();
		//echo " 2 " . WoogleUtil::getWooglePath();
		
		$i = stripos(WoogleUtil::getWoogleAbsolutePath(), WoogleUtil::getWooglePath());
		echo "I is: " . $i . ' of ' . WoogleUtil::getWoogleAbsolutePath() . ' / ' . WoogleUtil::getWooglePath();
		$this->assertTrue($i > 0);
		*/
	 }
	 
	 public function testURLs(){
		 $uri = WoogleUtil::getWoogleAbsolutePath();
		 //echo "URI - " . $uri . " - URI";
		 $this->assertTrue( filter_var($uri, FILTER_VALIDATE_URL, FILTER_FLAG_SCHEME_REQUIRED) != false );
	 }
	 
	 public function testExtractField(){
		$before = 'file=test.txt&name=test&type=class';
		
		$after = 'file=test.txt&name=test';
		$process = WoogleUtil::extractField($before, 'type');
		$this->assertEquals($after, $process);
		
		$after = 'file=test.txt&type=class';
		$process = WoogleUtil::extractField($before, 'name');
		$this->assertEquals($after, $process);
		
	 }
	 
	  public function testErrorLog(){
	  	WoogleConfig::set('writeLogsToShell', false);
		$logline = 'WoogleUtilTest' . microtime();
		WoogleUtil::error($logline);
		$i = strpos(WoogleUtil::getErrors(), $logline);	// check if log stament is contained in file
		$this->assertTrue($i > 0);
		WoogleConfig::set('writeLogsToShell', true);
	  }

    public function testGetServices(){
		$this->assertNotNull(WoogleUtil::getQueryService());
		$this->assertNotNull(WoogleUtil::getQueryManager());
		$this->assertNotNull(WoogleUtil::getIndexService());
    }

    public function testGetSecretKey(){
    	global $wgSecretKey, $wgDBpassword, $wgDBname;
    	$this->assertTrue(strlen(WoogleUtil::getSecretKey()) > 0);
    	$wgSecretKey = '';
    	$this->assertTrue(strlen(WoogleUtil::getSecretKey()) > 0);
    	$wgDBpassword = '';
		$this->assertTrue(strlen(WoogleUtil::getSecretKey()) > 0);
    	$wgDBname = '';
    	$this->assertTrue(strlen(WoogleUtil::getSecretKey()) == 0);
    }
	  
	
	public function testGetAnonUserID(){
		global $wgUser;
		
		//$wgUser = new TestUser();
		$this->assertEquals('i_' . md5(WoogleUtil::getSecretKey() . '127.0.0.1'), WoogleUtil::getAnonUserID()); // anon
		
		//echo 'A__' . WoogleConfig::getPref('Privacy', 'RandomUserID');
		// shows a94c022440f10ccdd9dc1debbf32c6e4 (=default value)
		
		$wgUser = new MockUser('wikisysop');
		//echo 'B__' . WoogleConfig::getPref('Privacy', 'RandomUserID');
		// shows a94c022440f10ccdd9dc1debbf32c6e4 (=still default value)
		
		WoogleConfig::setPref('Privacy', 'RandomUserID', 'wikisysop_id');
		//echo 'C__' . WoogleConfig::getPref('Privacy', 'RandomUserID');
		// shows wikisysop_id
		$this->assertEquals('wikisysop_id', WoogleUtil::getAnonUserID());

		$wgUser = new MockUser('karl_heinz');
		WoogleConfig::setPref('Privacy', 'RandomUserID', 'karlheinz_id');
		$this->assertEquals('karlheinz_id', WoogleUtil::getAnonUserID());
		
	}
}



?>
