<?php

global $wooNamespaceIndex;
$wooNamespaceIndex = 110; // test data uses WOO_NS_MAIN=110

chdir('../../../');
global $wgAutoloadClasses, $argv, $IP;

//require_once('includes/WebStart.php');
require_once('maintenance/commandLine.inc' );

//require_once 'PHPUnit/Framework.php';
//require_once 'PHPUnit.php';
//require_once 'PHPUnit2/Framework/TestCase.php';
require_once 'PHPUnit/Framework/TestCase.php';

require_once('tests/MediaWiki_TestCase.php' );

//$wgDBserver, $wgDBuser, $wgDBpassword, $wgDBname, $wgDBtype, $wgDebugDumpSql;
global $wgDBprefix, $wgDBadminuser, $wgDBadminpassword;
$wgDBprefix = 'parsertest_';
$wgDBadminuser = 'root';
$wgDBadminpassword = '';

WoogleConfig::set('indexRepository', 999);
WoogleConfig::set('useDebugLogging', true);
WoogleConfig::set('writeLogsToShell', true);

echo "Encoding set to: " . mb_internal_encoding() . "\n";
if (!mb_internal_encoding("UTF-8")) echo "ERROR setting encoding to UTF-8!" . "\n";
echo "Encoding set to: " . mb_internal_encoding() . "\n";

# Error reporting (only useful for debugging)
//error_reporting( E_ALL );
//ini_set( 'display_errors', 1 );
//$wgShowExceptionDetails = true; 
//$wgShowSQLErrors = true;

/*
set_include_path(implode(PATH_SEPARATOR, array(
    realpath('R:/dev/htdocs/mw1150/'),
    get_include_path(),
)));*/

class Woogle_TestCase extends MediaWiki_TestCase{
	
	protected $qs;
	protected $qm;
	protected $is;
 	protected $db;

	// test data summary (c.f. insertTestData() and prepareQueryTestData())
 	protected $num_test_docs = 10;
	protected $num_test_queries = 5;
	protected $num_testde_clicks = 3;
	protected $num_diff_queries = 5;
	protected $num_diff_results = 3;
	protected $num_test_clicks = 5;

    protected function setUp(){
    }
	
	protected function tearDown(){
	}
	
	protected function prepareQueryService(){
		$this->qs =  WoogleUtil::getQueryService();
	}
	
	protected function prepareQueryManager(){
		$this->qm =  WoogleUtil::getQueryManager();
	}

	protected function prepareTestIndex(){
		// prepare test index
    	$this->is =  WoogleUtil::getIndexService();
		WoogleLucene::setIndexPath(dirname(__FILE__) . '/data/index/test');
		WoogleLucene::getIndex(true); // overwrite
		$this->is->index(true); // index all
	}
	
	protected function prepareTestDb(){
		// prepare test db
		$this->db = $this->buildTestDatabase( array('page', 'revision', 'text', 'watchlist', 'pagelinks', 'image') );
		//$this->db = $this->buildTestDatabase( array('page', 'revision', 'text', 'watchlist', 'pagelinks', 'image', 'user') );
		$this->insertTestData();
		WoogleMWUtil::setDB($this->db);			// set master
		WoogleMWUtil::setDB($this->db, false);	// set slave
		
	}
	
	protected function insertTestData() {
		
		// NOTE: keep $this->num_test_docs in sync!
		
		$this->db->safeQuery( <<<END
		INSERT INTO ! (page_id,page_namespace,page_title,page_latest)
		VALUES (1, 0, 'Main_Page', 1),
			   (2, 1, 'Talk:Main_Page', 2),
			   (3, 0, 'Smithee', 3),
			   (4, 1, 'Talk:Smithee', 4),
			   (5, 0, 'Unrelated_page', 5),
			   (6, 0, 'Veränderung', 6),
			   (7, 4, 'Help', 7),
			   (8, 0, 'Thppt', 8),
			   (9, 0, 'Alan_Smithee', 9),
			   (10, 0, 'Pages', 10),
			   (11, 0, 'Heiko Haller/Chairing', 11)
END
			, $this->db->tableName( 'page' ) );
		
		$this->db->safeQuery( <<<END
		INSERT INTO ! (rev_id,rev_page)
		VALUES (1, 1),
		       (2, 2),
		       (3, 3),
		       (4, 4),
		       (5, 5),
		       (6, 6),
		       (7, 7),
		       (8, 8),
		       (9, 9),
		       (10, 10),
		       (11, 11)
END
			, $this->db->tableName( 'revision' ) );
		
		$this->db->safeQuery( <<<END
		INSERT INTO ! (old_id,old_text)
		VALUES (1, 'This is a main page - note please'),
			   (2, 'This is a talk page to the main page, see [[smithee]]'),
			   (3, 'A smithee is one who smiths. See also [[Alan Smithee]]'),
			   (4, 'This article sucks.'),
			   (5, 'Nothing in this page is about the S word - talk loudly.'),
			   (6, 'This page also is unrelated.'),
			   (7, 'Help me! - überhaupt nicht!'),
			   (8, 'Blah blah erlebt ein Überraschung und [[Veränderung]]!'),
			   (9, 'yum'),
			   (10,'are food'),
			   (11,'A Meeting')
END
			, $this->db->tableName( 'text' ) );
			
			// NS 110 = NS_WOOGLE
		$this->db->safeQuery( <<<END
		INSERT INTO ! (wl_user,wl_namespace,wl_title)
		VALUES (1, 110, 'Test'),
		       (1, 0, 'Main_Page'),
		       (2, 110, 'Test')
END
			, $this->db->tableName( 'watchlist' ) );
			
		$this->db->safeQuery( <<<END
		INSERT INTO ! (pl_from,pl_namespace,pl_title)
		VALUES (2, 0, 'Smithee'),
		       (3, 0, 'Alan_Smithee'),
		       (8, 0, 'Veränderung')
END
			, $this->db->tableName( 'pagelinks' ) );
			
		/*
		$this->db->safeQuery( <<<END
		INSERT INTO ! (user_id,user_name)
		VALUES (1, 'WikiSysop'),
		       (2, 'KarlHeinz')
END
			, $this->db->tableName( 'user' ) );
		*/
			
	}
	
	protected function prepareQueryTestData(){
		$rx = $this->qm->initDb();
//		echo "\n calling prepareQueryTestData() $rx tables created by initDb";
		$this->qm->handleQuery('Test', 20);
		$this->qm->handleQuery('Test', 20);
		$this->qm->handleQuery('test', 20);
		$this->qm->handleQuery('TesT', 20);
		$this->qm->handleQuery('TEsT', 20);
		$this->qm->handleQuery('Test Query', 20);
		$this->qm->handleQuery('Test Query', 20);
		$this->qm->handleQuery('Test Magazine', 20);
		$this->qm->handleQuery('Test Ümläut', 20);
		$this->qm->handleQuery('Test Umlaut', 20);
		$this->qm->handleClick('Test', 'http://www.test.de', 1, '');
		$this->qm->handleClick('Test', 'http://www.test.de', 1, '');
		$this->qm->handleClick('Test', 'http://www.test.de', 1, '');
		$this->qm->handleClick('Test', 'http://www.test.com', 2, '');
		$this->qm->handleClick('Test', 'http://www.test.net', 3, '');
	}
	
	protected function prepareMuchQueryTestData($numRQ = 10000){

		// random test query generator
		$qStart = microtime(true);
		echo "RandomQueryGeneration for " . $numRQ . " queries starting\n";
		for ($i = 1; $i <= $numRQ; $i++) {
			$rnd = rand(1, 100000);
			$qx = md5($rnd);
			$this->qm->handleQuery($qx, 20);
			if (($i % 100) == 0) echo "Generated " . $i . " queries!" . "\n"; 
		}
		$qStop = microtime(true);
		$qTime = $qStop - $qStart;
		echo "RandomQueryGeneration-Time: " . $qTime . " for " . $numRQ . " queries" . "\n";
		
	}
	
	protected function removeQueryTestData(){
//		echo "\n calling dropDb";
		$this->qm->dropDb();
		
		$this->assertFalse(WoogleMWUtil::tableExists('woogle_aggquery'));
	}
	
	protected static function getValues(){
		return array(
			'mimetypes' 	=> null,
			'changedMin' 	=> 0,
			'changedMax' 	=> 0,
			'sizeMin' 		=> 0,
			'sizeMax' 		=> 0,
			'excludeId' 	=> 0,
			'sortType' 		=> 0,
		);
	}
	
}



?>
